<?php
/* HEADER */ if ($TWIST_FILE_INFO) {echo __FILE__.': $Id: OGR.inc,v 1.10 2008/02/07 13:43:35 tokr Exp $'.'$Name:  $';exit;}; /* HEADER */

require_once(FileUp2(".admin/main_editlayer.inc"));

class OGR_EditLayer extends EditLayer {

  function OGR_EditLayer($vobj) {
    $this->EditLayer($vobj);
//    $this->table_params['field_shape'] = $this->table_params['field_shape']?$this->table_params['field_shape']:'SHAPE';
    $this->table_params['field_id'] = $this->table_params['field_id']?$this->table_params['field_id']:'FID_';
    include_once(FileUp2('.admin/db/'.$this->db_file));
    $this->db = new $this->db_name;
    $this->db->connect();
    $this->met = $this->Metadata();
  }

  function Insert($shape, $attrib) {
    include_once(FileUp2('.admin/functions.inc'));
    if (!HasSubRole("insert")) return false;      
    $this->_PrepareSpecialFields('insert');
           
    $sql = CreateValuesSQLFromVar($this->met);
    $sql = preg_replace('/^\((.*)\) values \((.*)\)$/i', '(TMS_SHAPE_TYPE, TMS_SHAPE_COORDS, ${1}) VALUES ('.$shape['type'].',('.$shape['text'].'), ${2})', $sql);
    $sql = 'INSERT INTO '.$this->table_name.' '.$sql;
    $this->ret = $this->db->query($sql);
    return ($this->ret?true:false);
  }
  
  function Update($id, $shape, $attrib) {
    $this->ret = false;
    if (isset($id)) {
      include_once(FileUp2('.admin/functions.inc'));
      if(!HasAccessToRecord('update', $id)) return false;
      $this->_PrepareSpecialFields();
      
      $sql = CreateSetWhereSQLFromVar($this->met);
      if ($shape['type'] && $shape['text']) {
        $sql.=', TMS_SHAPE_TYPE='.$shape['type'].', TMS_SHAPE_COORDS='.$shape['text']; 
      }
      $sql = 'UPDATE '.$this->table_name.' SET '.$sql.' WHERE '.$this->table_params['field_id'].'='.$id.'';
      $this->ret = $this->db->query($sql);
    }
    return ($this->ret?true:false);
  }

  function Delete($id) {
    $this->ret = false;
    if (isset($id)) {
      include_once(FileUp2('.admin/functions.inc'));
      if(!HasAccessToRecord('delete', $id)) return false;
      $sql = 'DELETE FROM '.$this->table_name.' WHERE '.$this->table_params['field_id'].' IN ('.$id.')';
      $this->ret = $this->db->query($sql);
    }
    return ($this->ret?true:false);
  }

  function Metadata() {
    $met = $this->db->metadata($this->table_name);
    return $met;
  }
  
  function PrepareTableParams($shape,$table_par=array()) {
//    $sql = 'SELECT * FROM '.$this->table_name.' WHERE TMS_BBOX=('.$shape['rect'][0]['x'].','.$shape['rect'][3]['y'].','.$shape['rect'][1]['x'].','.$shape['rect'][0]['y'].')';
    $sql = 'SELECT * FROM '.$this->table_name; 
    $filter = false;
    if (!$GLOBALS['PROPERTIES_ACCESS']['all_read']) {
      $user_info = $GLOBALS["TMAPY_SECURITY"]->getUserInfo();
      if ($GLOBALS['PROPERTIES_ACCESS']['owner_read']) {
        $FLD_OWNER_ID = $this->table_params['special_fields']["FIELD_OWNER_ID"]?$this->table_params['special_fields']["FIELD_OWNER_ID"]:"OWNER_ID";
        $sql .= " WHERE $FLD_OWNER_ID={$user_info['ID']}";
        $filter = true; 
      } 
    }
    $sql .= ($filter?' AND':' WHERE').' INTERSECTS(TMS_SHAPE_TYPE='.$shape['type'].' AND TMS_SHAPE_COORDS='.$shape['text'].')';
    if ($this->vobj->layer_properties['table']['order_by']) {
      $sql .= ' ORDER BY '.$this->vobj->layer_properties['table']['order_by'];
    }
    $table_par['sql'] = $sql;
    $table_par["properties"] = $this->_GetTableProperties();
    $table_par['table_schema'] = array('schema'=>$this->vobj->layer_properties['table']['schema']);
    $table_par['noprint']=true;
    $table_par['nopaging']=true;
//    $table_par['showedit']=true;
    return $table_par;
  }
  
  function PrepareFormData($id) {
    if (isset($id)) {
      $met = $this->met;
      $sql = 'SELECT *, FWKT_ FROM '.$this->table_name.' WHERE '.$this->table_params['field_id'].'IN ('.$id.')';
      @$this->db->query($sql);
      if ($this->db->next_record()) {
        SetVarFromHash(&$this->db->Record);
      }
      return $this->db->Record; 
    }
  }

  function _GetTableProperties() {
    $this->_PrepareSpecialFields();
    $special_fields = $this->table_params['special_fields'];
    $FLD_OWNER_ID = $special_fields["FIELD_OWNER_ID"]?$special_fields["FIELD_OWNER_ID"]:"OWNER_ID";
    return array(
      'DB_NAME'=>$this->db_name,
      'AGENDA_ID'=>$this->table_params['field_id'],
      'AGENDA_TABLE'=>$this->table_name,
      'ACCESS_UPDATE_OWNER_ID'=>$FLD_OWNER_ID
    );
  }  
  
  function _PrepareSpecialFields($operation='update') {
    $special_fields = $this->table_params['special_fields'];
    $FLD_OWNER_ID = $special_fields["FIELD_OWNER_ID"]?$special_fields["FIELD_OWNER_ID"]:"OWNER_ID";
    $FLD_OWNER_NAME = $special_fields["FIELD_OWNER_NAME"]?$special_fields["FIELD_OWNER_NAME"]:"OWNER_NAME";
    $FLD_UPDATE_DATE = $special_fields["FIELD_UPDATE_DATE"]?$special_fields["FIELD_UPDATE_DATE"]:"LAST_DATE";
    $FLD_UPDATE_TIME = $special_fields["FIELD_UPDATE_TIME"]?$special_fields["FIELD_UPDATE_TIME"]:"LAST_TIME";
    $FLD_UPDATE_ID = $special_fields["FIELD_UPDATE_ID"]?$special_fields["FIELD_UPDATE_ID"]:"LAST_USER_ID";
    $FLD_UPDATE_NAME = $special_fields["FIELD_UPDATE_NAME"]?$special_fields["FIELD_UPDATE_NAME"]:"LAST_USER_NAME";
    $FLD_UPDATE_GROUP_ID = $special_fields["FIELD_UPDATE_GROUP_ID"]?$special_fields["FIELD_UPDATE_GROUP_ID"]:"LAST_GROUP_ID";
     
    //Konverze pro datum
    $met = $this->met;
    reset($met);
    while (list($key, $val) = each($met)):
      switch (strtolower($val["type"])):
        case "date":
        case "datetime":
        case "smalldatetime":
    //		  eval("global $".$val["name"]);
    			if (isset($GLOBALS[$val["name"]])):
      			$GLOBALS[$val["name"]] = $this->db->str2dbdate($GLOBALS[$val["name"]]);
    			endif;
      endswitch;
    	if (!$owner){ $owner = ($val["name"] == $FLD_OWNER_ID);}
      if (!$owner_name){ $owner_name = ($val["name"] == $FLD_OWNER_NAME);}  
    	if (!$date){ $date = ($val["name"] == $FLD_UPDATE_DATE);} 
    	if (!$time){ $time = ($val["name"] == $FLD_UPDATE_TIME);} 
    	if (!$update_id){ $update_id = ($val["name"] == $FLD_UPDATE_ID);}
      if (!$update_name){ $update_name = ($val["name"] == $FLD_UPDATE_NAME);} 
    	if (!$group_id){ $group_id = ($val["name"] == $FLD_UPDATE_GROUP_ID);} 
    endwhile;
    include_once(FileUp2(".admin/security_obj.inc"));  
    $USER_INFO = $GLOBALS["TMAPY_SECURITY"]->GetUserInfo();
    
    if($GLOBALS["TMAPY_SECURITY"]->q->Encoding && $this->db->Encoding) {
      foreach($USER_INFO as $par=>$val) {
        $USER_INFO[$par] = iconv($GLOBALS["TMAPY_SECURITY"]->q->Encoding,$this->db->Encoding,$val);
      }      
    } 
    
    if($operation=='insert') {
      if($owner) $GLOBALS[$FLD_OWNER_ID] = $USER_INFO['ID'];
      if($owner_name) $GLOBALS[$FLD_OWNER_NAME] = $USER_INFO['FNAME'].' '.$USER_INFO['LNAME'];
      if ($special_fields['FIELD_AUTOINCREMENT']) 
        $GLOBALS[StrToUpper($special_fields['FIELD_AUTOINCREMENT'])] = '***auto***';
    }
    if($date) $GLOBALS[$FLD_UPDATE_DATE] = $this->db->date2dbdate();
    if($time) $GLOBALS[$FLD_UPDATE_TIME] = $this->db->time2dbtime();
    if($update_id) $GLOBALS[$FLD_UPDATE_ID] = $USER_INFO["ID"];
    if($update_name) $GLOBALS[$FLD_UPDATE_NAME] = $USER_INFO['FNAME'].' '.$USER_INFO['LNAME'];
    if($group_id) $GLOBALS[$FLD_UPDATE_GROUP_ID] = $USER_INFO["GROUP_ID"];
  }  

}
?>
